// NAMESPACE FOR SCHEDULE FUNCTIONS
var SCHEDULE = {

  Init : function (source, callback) {

    var months = [
      "January", "February", "March", "April",
      "May", "June", "July", "August", "September",
      "October", "November", "December"];

    // get today's date
    var d = new Date();
    var m = d.getMonth();
    var y = d.getFullYear();

    var ind = 1; // starting index number (for select operations)
    var numMonths = 9; // number of months to be generated SR
    var firstMonth = 7; // subtract one from the actual number
    if( m != firstMonth ){ m = firstMonth; }
    var numDays = 0; // number of days in month
    var first = 0; //
    var frontpad = 0; //
    var afterpad = 0; //
    var thisDate = ""; //

    var calText = "";
    document.getElementById("calendar").innerHTML = calText;

    var i = numMonths;

    while (i > 0) {

      numDays = new Date(y, (m+1), 0).getDate();

      first = new Date(y,m,1);

      frontpad = first.getDay();
      afterpad = (7 - ((frontpad + numDays) % 7)) % 7;

calText = "<div class=\"month row-fluid " + months[m];
calText += "\"><div class=\"month-hed\"><a class=\"cal-prev month-arrow\">&lt;</a>";
calText += "<a class=\"cal-next month-arrow\">";
calText += "&gt;</a><h3 class=\"text-center\">" + months[m] + " " + y;
calText += "</h3></div><div class=\"day-wrapper\"><div class=\"day day-name\">Sun</div>";
calText += "<div class=\"day day-name\">Mon</div><div class=\"day day-name\">Tue</div>";
calText += "<div class=\"day day-name\">Wed</div><div class=\"day day-name\">Thu</div>";
calText += "<div class=\"day day-name\">Fri</div><div class=\"day day-name\">Sat</div>";

      for (j = 1; j <= frontpad; j++) {
        calText += "<div class=\"day off_set\">&nbsp;</div>";
      }

      for (j = 1; j <= numDays; j++) {
        if (m < 9) {
          if (j <= 9) {
            thisDate = y + "-0" + (m+1) + "-0" + j;
          } else {
            thisDate = y + "-0" + (m+1) + "-" + j;
          }
        } else {
          if (j <= 9) {
            thisDate = y + "-" + (m+1) + "-0" + j;
          } else {
            thisDate = y + "-" + (m+1) + "-" + j;
          }
        }
        calText += "<div class=\"day "+thisDate+"\"><p class=\"date\">" + j + "</p>";
        calText += "</div>";
        ind++;
      }

      for (j = 1; j <= afterpad; j++){
        calText += "<div class=\"day off_set\">&nbsp;</div>";
      }

      calText +=  "</div></div>";

      m++;

      if (m==12) {
        m = 0;
        y++;
      }

      document.getElementById("calendar").innerHTML += calText;

      calText = "";

      i--;
    }

    SCHEDULE.Functions();

  },

  Functions : function (source, callback) {

    /* --- CAL FUNCTIONS --*/
    var curMonth = 3;
    var curDate = "";
    var numViewable = 1; // number of months that should be viewable at one time

    for ( i=curMonth; i <= (curMonth+numViewable-1); i++) {
      $(".month:nth-child("+i+")").addClass("active");
    }

    $(".cal-next, .cal-prev").click(function(e){

      e.preventDefault();

      $(".month").removeClass("active");

      if( $(this).hasClass("cal-next") ){

        curMonth++;
        if( curMonth == 2 ){ $(".cal-prev").show(); }
        if((curMonth+numViewable-1)==$(".month").length){$(".cal-next").hide();}
        if( curMonth == 1){ $(".cal-prev").hide(); }

      } else {

    curMonth--;
    console.log(curMonth);
    if( curMonth == 2 ){ $(this).hide(); }
    if((curMonth+numViewable-1)==($(".month").length-1)){$(".cal-next").show();}
    if( curMonth == 1 ){ $(".cal-prev").hide(); }

      }

      for (i=curMonth;i<=(curMonth+numViewable-1);i++) {
        $(".month:nth-child(" + i + ")").addClass("active");
      }

    });

    SCHEDULE.Fetch("_data/schedule.json", function(){
      SCHEDULE.Telecharge("#calendar","Trevor");
    });

    function adjustLink() {
      var numShows;
      $( ".day" ).each(function() {
        numShows = $(this).children("span.event").length;
        if(numShows === 1) {
          $(this).children(".eve").addClass("oneShow");
          $(this).children(".mat").addClass("oneShow");
        } else if(numShows === 2){
          $(this).children(".eve").addClass("secShow");
          $(this).children(".mat").addClass("firShow");
        } else {
          $(this).addClass("noshow");
        }
      });
    }
    setTimeout(adjustLink, 500);

    $(".question").on( "click", function(e) {
      e.preventDefault();
      if($(this).parent(".faq-item").hasClass("active")) {
        $(this).parent(".faq-item").removeClass("active");
      } else {
        $(".faq-item").removeClass("active");
        $(this).parent(".faq-item").addClass("active");
      }
    });


    $(".tix-pics > div:gt(0)").hide();
    setInterval(function() {
      $(".tix-pics > div:first")
        .fadeOut(1000)
        .next()
        .fadeIn(1000)
        .end()
        .appendTo(".tix-pics");
      }, 3000);

    function heightFix() {
      var slideHeight = $(".tix-rotate").height();
      $(".tix-pics").height(slideHeight);
    }

    heightFix();

    $(window).resize(function() {
        "use strict";
        heightFix();
    });

    /*jQuery(document).on("click", ".month h3", function(e){
      e.stopPropagation();
      e.preventDefault();
      if( jQuery(this).parents(".month").hasClass("active") ){
        jQuery(this).parents(".month").removeClass("active");
        jQuery(this).parents(".month").children(".day-wrapper").slideUp();
      } else {
        jQuery(this).parents(".month").addClass("active");
        jQuery(this).parents(".month").children(".day-wrapper").slideDown();
      }
    });*/
  },

  // JSON results for show dates and times will be stored here
  Times : null,
  Avail : null,

  // Get JSON file, call appropriate parsing function after
  Fetch : function (source, callback) {
      jQuery.getJSON(source, function(data) {
          var showKey = "";
          var showDate = "";
          // Format dates if Ticketmaster calendar
          if (data.contents) {
              SCHEDULE.Times = data.contents;
              for (key in SCHEDULE.Times) {
                  showKey = SCHEDULE.Times[key].event_SEO_name;
                  if(showKey){
                    showDate = showKey.slice(-10).split ("-");
                    SCHEDULE.Times[key].date = showDate[2] + "-" + showDate[0];
                    SCHEDULE.Times[key].date += "-" + thisDate[1];
                  }
              }
          } else {
              SCHEDULE.Times = data;
          }
          callback ();
      });
  },


  // Initalize calendar in container, pass it parsed events list array with
  // ticket links
  Populate : function (container, eventslist, callback) {

      // Figure out first and last performances
      var maxdate = new Date (SCHEDULE.Times [SCHEDULE.Times.length - 1].date);
      var mindate;
      if (new Date (SCHEDULE.Times [0].date) >= new Date ()) {
          mindate = new Date (SCHEDULE.Times [0].date);
      } else {
          mindate = new Date ();
      }

      var eventDate = "";
      var eventTime = "";
      var typeShow = "";
      var showAvail = "";
      //var showHighlight = "";
      var eventInfo = "";

      for (i=0; i < eventslist.length; i++) {

        eventDate = "." + eventslist[i].start.slice(-10);
        eventTime = eventslist[i].title;
        typeShow = eventslist[i].className;
        showAvail = eventslist[i].avail;
        //showHighlight = eventslist[i].highlight;
        eventInfo = "<span class=\"event num" + (i + 1) + " " + typeShow + " " + showAvail + "\"><a class=\"show-link\" target=\"_blank\" data-showdate=\"" + eventslist[i].cleanDate + "\" data-showtime=\"" + eventTime + "\" href=\""+ eventslist[i].url +"\">" + eventTime.substring(0, 4) + "</a></span>";
        jQuery(".month").find(eventDate).append(eventInfo);
      }

      callback();
  },

  // make show links flicker
  Flicker : function () {

      /*
      $(".show-link").each(function(){
        $(this).addClass("flicker");
        console.log("yo");
      });
      */

      // calendar hilight

      $.fn.isInViewport = function() {

        var elementTop = $(this).offset().top;
        var elementBottom = elementTop + $(this).outerHeight();

        var viewportTop = $(window).scrollTop();
        var viewportBottom = viewportTop + $(window).height();

        return elementBottom > viewportTop && elementTop < viewportBottom;
      };

      $(window).on('resize scroll', function() {
        $('.month').each(function() {
          var activeColor = $(this).attr('id');
          if ($(this).isInViewport()) {
            $(".show-link").each(function(i){
              //delayTime = i * .125 + 's';
              $(this).removeClass("flicker").addClass("flicker")/*.css({
                'animation-delay' : delayTime
              })*/;
              console.log("yo");
            });
          }
        });
      });

  },

  // HUDSON THEATER LINK PULL
  Telecharge : function (container, telecode) {
      var eventslist = [];

      //Date fix
      var calDate = new Date();
      calDate.setDate(calDate.getDate() - 1);

      //console.log(SCHEDULE.Times);
      var dateformatted = "";
      var timeformatted = "";

      for (var i=0; i < SCHEDULE.Times.length; i++) {

dateformatted = (SCHEDULE.Times [i].date).split ("-");
dateformatted = eval(dateformatted[1])+"/"+dateformatted[2]+"/"+dateformatted[0];

          timeformatted = "0" + SCHEDULE.Times [i].showtime.substr(0,4) + "PM";

          if (calDate <= new Date (SCHEDULE.Times [i].date)) {
              eventslist.push ({
                  start : SCHEDULE.Times [i].date,
                  url : 'https://www.telecharge.com/Off-Broadway/' + telecode + '/Ticket?PerformanceDateTime=' + dateformatted + '%20' + timeformatted,
                  title : SCHEDULE.Times [i].showtime,
                  type : "Telecharge",
                  cleanDate : dateformatted,
                  availClass: SCHEDULE.Times [i].avail
              });
          }
      }
      SCHEDULE.Populate (container, eventslist, SCHEDULE.Flicker);
  }
};

jQuery(document).ready(function(){

  SCHEDULE.Init();

});
