/**
 * core.js - all global scripts belong in this file.
 */

// NAMESPACE FOR COMMON FUNCTIONS/OBJECTS
var COMMONUTILS = {
    //
    pageWidth : function () {"use strict";
        return document.documentElement.clientWidth;
    },

    // OBJ TO HOLD USERS CURRENT WEBPAGE LOCATION
    currentPage : window.location.pathname.substring (window.location.pathname.lastIndexOf ('/') + 1),

    // FUNCTION TO EXECUTE CODE BASED ON LOCATION
    userLocation : function (pagename) {"use strict";
        var page = pagename;
        $ ('#nav a').removeClass ('active');
        switch(page) {
            case 'index':
                $ ('#nav-home').addClass ('active');
                break;
            case 'about':
                $ ('#nav-about').addClass ('active');
                break;
            case 'cast':
                $ ('#nav-cast').addClass ('active');
                break;
            case 'news':
                $ ('#nav-news').addClass ('active');
                break;
            case 'reviews':
                $ ('#nav-reviews').addClass ('active');
                break;
            case 'tickets':
                $ ('#nav-tickets').addClass ('active');
                break;
            case 'gallery':
                $ ('#nav-gallery').addClass ('active');
                break;
            case 'privacy':
                $ ('#nav a').removeClass ('active');
                break;
            default:
                // No Case
                $ ('#nav-home').addClass ('active');
        }
    },

    optinFormValidate: function() {
    	"use strict";

      var formName = "";

      $(".subscribe").each(function(i){

      	//console.log(i);
      	formName = "optin"+i;
      	$(this).attr("id",formName);

          //
          $(this).validate({
            rules : {
              email : { required : true, email : true }/*,
              zip : 'required'*/
            },
            messages : {
              email : 'Enter a valid email'/*,
              zip : 'Enter your zip code'*/
            },
            errorPlacement : function(error, element) {
              element.attr('placeholder', error[0].outerText);
            },
            submitHandler : function(form) {
              $.ajax({
                url : './_inc/optin_action.php',
                type : 'POST',
                data : $(form).serialize() + '&ajax=true',
                success : function() {
                  $(form).hide();
                  $('.ageHeader').hide();
                  $(form).parent("div").append('<h3 class="text-center form-thanks">THANK YOU FOR SIGNING UP<br /><span>Check your email to confirm your subscription.</span></h3>');
                }
              });
              return false;
            }
          });

      });
    },

    nav: function() {
    	"use strict";

    	$("#btn-menu").on("click",function(e){
      	e.preventDefault();
      	if( $("#nav").hasClass("open") ){
        	$("#nav, #btn-menu").removeClass("open");
        	$("#btn-menu").removeClass("fa-times-thin").addClass("fa-bars");
      	} else {
        	$("#nav, #btn-menu").addClass("open");
        	$("#btn-menu").addClass("fa-times-thin").removeClass("fa-bars");
      	}
    	});

    	$("#icon-envelope").click(function(){
      	$("html").addClass("modal-open");
    	});

    },

    video: function() {
    	"use strict";

    	$(".video-link").each(function(e){
      	  if( $(this).data("thumb") != "" ){
        	  $(this).html('<div class="video-thumb"><img src="'+ $(this).data("thumb") +'" class="w100"></div>');
      	  } else {
        	  $(this).html('<div class="video-thumb"><img src="http://img.youtube.com/vi/'+ $(this).data("id") +'/hqdefault.jpg" class="w100"></div>');
      	  }
      	  if( $(this).data("caption") != "" ){
      	    //console.log('yo');
        	  $(this).append("<div class='video-caption'>"+$(this).data("caption")+"</div>");
      	  }
    	});

    	$(document).on("click",".video-link",function(e){
    	    e.preventDefault();
    	    if( $("#video-overlay-close").length == 0 ){
      	    $("#video-overlay").append('<a id="video-overlay-close"></a>');
    	    }
        	$("#video-overlay-inner").html('<iframe src="https://www.youtube.com/embed/'+ $(this).data("id") +'?rel=0&modestbranding=1&autohide=1&showinfo=0&autoplay=1" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>');
        	$("html").addClass("video-overlay-open");
    	});

    	$(document).on("click","#video-overlay-close, #video-overlay",function(e){
    	    e.preventDefault();
        	$("#video-overlay-inner").html('');
        	$("html").removeClass("video-overlay-open");
    	});

    },

    quotes: function() {
    	"use strict";
      $('#quotes').quote_rotator();

    }
};

//Namespace for bio functions
var bioGrid = {};

bioGrid.bioindex = 0;
bioGrid.bios = [];

bioGrid.loadBios = function (divID, page) {"use strict";
    //Cast & Creative Bios
    $(divID).load(page, null, function () {
        //
        if (divID === "#cast-bios") {
            var thumbs = "";
            for (var i=1; i <= $("#cast-bios .team-member").length; i++) {
                thumbs += '<a class="cast-member actor-' + i + '" href="#' + (i - 1) + '" ><div class="cast-image">' + $('#cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-name">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 strong').html() + '</div><div class="cast-role">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 em').html() + '</div></a>';
                bioGrid.bios.push($('#cast-bios .team-member:nth-child('+i+')').html());
            }
        }

        $(divID).html(thumbs);

        $(divID + " .cast-member").click( function(e) {
            e.preventDefault();
            bioGrid.bioindex = Number($(this).attr("href").split("#")[1]);

            //add overlay
            $("#overlay-inner").html("").html("<div>" + bioGrid.bios [ ($(this).attr("href").split("#") [1]) ] + "</div>");
            $("html, body").addClass ("overlay-open");
            $(".overlay").addClass ("open");


            //next/prev
            $(".overlay-prev, .overlay-next").show();
            if (bioGrid.bioindex == (bioGrid.bios.length - 1)) {
                $(".overlay-next").hide();
            } else if (bioGrid.bioindex == 0) {
                $(".overlay-prev").hide();
            }

            //scroll, if necessary
            if ( $('.overlay .container').height() > $(window).height() ) {
                var slideheight = $(window).height () - $(".overlay-close").height()*2 - 100;
                $('#overlay-inner > div').slimscroll ({
                    height : slideheight + 'px', alwaysVisible : true, color : '#2dc2cd', railVisible : true, railColor : '#000'
                });
            }
        });
    })
};

//Next/Previous navigation
bioGrid.bioNav = function () {
    $(".overlay-next").click(function(e) {
        e.preventDefault();
        $(".overlay-prev").show();
        if (bioGrid.bioindex == (bioGrid.bios.length - 2)) {
            $(this).hide();
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex + 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });

    $(".overlay-prev").click(function(e) {
        e.preventDefault();
        $(".overlay-next").show();
        if (bioGrid.bioindex == 1) {
            $(this).hide();
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex - 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });
};

// Close Cast Overlay
bioGrid.hideOverlay = function () {
    $ (".overlay-close").click (function (e) {
        e.preventDefault ();
        $ ("html, body").removeClass ("overlay-open");
        $ (".overlay").removeClass ("open");
    });
};

// jQuery Namespace
$ (document).ready (function () {"use strict";
    $('html').addClass('page-loaded');
    COMMONUTILS.optinFormValidate();

    $(document).on('click', '.open-call', function(e) {
      e.preventDefault();
       $([document.documentElement, document.body]).animate({
         scrollTop: ($("#details").offset().top) - 20
       }, 800);
    });

    $(document).on('click', '.vid-call', function(e) {
      e.preventDefault();
       $([document.documentElement, document.body]).animate({
         scrollTop: ($("#vid-submit").offset().top) - 20
       }, 800);
    });

    /*$(document).on('click', '#btn-tickets', function(e) {
      e.preventDefault();
       $([document.documentElement, document.body]).animate({
         scrollTop: ($("#calendar").offset().top) - 100
       }, 800);
    });*/

    if(navigator.userAgent.toLowerCase().indexOf('firefox') > -1){
     // Do Firefox-related activities
     $("html").css('backgroundColor','rgb(2, 21, 51)');
    }

    //Corona Messaging
    /*function snipeHeight() {
      var snipe = $('.corona').height();
      $('header').css("top", snipe);
      var width = $(window).width();
      if (width <= 750) {
        $('#content').css("padding-top", (snipe + 50));
        $('#header').css("top", snipe);
      } else {
        $('#content').css("padding-top", (snipe + 120));
        $('#header').css("top", snipe);
      }

    }

    snipeHeight();

    $(window).resize(function() {
        snipeHeight();
    });*/



    // Age Gate


    // Calculate your age based on inputs
    $(function(){
    	      	var day = $("#birthDay").val();
                var month = $("#birthMonth").val();
                var year = $("#birthYear").val();
    // Disallow Letters into the Age Gate Input Fields
    $('#ageGateForm input.ageInput').on('input', function() {
     this.value = this.value.replace(/[\s\D]/g, '', function(){
     });
     if ($(this).val().length == $(this).attr('maxlength'))  {
    	if($('#birthDay').val() > 31 || $('#birthMonth').val() > 12 || $('#birthYear').val() > 2019) {
    		$(this).val('');
    		}
    	if($('html').hasClass('no-touch')) {
     		$(this).parent().next().find('input.ageInput').focus();}
     	};
    });


    // FORM Submit
    $("#ageGateForm").submit(function(){
    			var day = $("#birthDay").val();
          var month = $("#birthMonth").val();
          var year = $("#birthYear").val();
          var age  = $("#requiredAge").val();

          // If Input Fields are left empty or not Formatted Correctly Display Message
          if (day == "" || month == "" || year == "" || month.length < 2 || day.length < 2 || year.length < 4){
          	$('li.errors').html("Please fill out all fields with the correct formatting.").slideDown(300);

            return false
           }
          var mydate = new Date();
          mydate.setFullYear(year, month-1, day);

          var currdate = new Date();
          currdate.setFullYear(currdate.getFullYear() - age);

          //  If Underage Redirect to Google Homepage
          if ((currdate - mydate) < 0){
          	   $('#ageGateForm').html("<p class='message'>Sorry, only persons over the age<br /> of " + age + " may sign up</p>");
               return false
           }


           // If Age is Validated Hide form and show contents
          else {
            $('.ageHeader span').hide();
            $('#ageGate').hide();
            $('.optin').addClass('show');
    			   return false
          }

          });
      });

      $('.modal-close').click(function(e) {
          e.preventDefault();
          $('#popup-blue').hide();
      });

});

// EOF
